#include <iostream>
#include <fstream>
#include <sstream>
#include <string>

using namespace std;

const int maxn = 100;

int n, a[maxn];
int m, b[maxn];

int err_code;
string err_message;

int get_answer(ifstream &f) {
    err_code = 0;
    int ans = 0;

    int cur_bus = 0;
    int cur_size = 0;

    for (int i = 0; i < n; i++) {
        int p;
        f >> p;
        if (!f) {
            ostringstream ss;
            ss << "illegal output format discovered at delegation " << i + 1;
            err_code = 2;
            err_message = ss.str();
            return 0;
        }
        ans += p;
        int delegation_size = 0;
        for (int j = 0; j < p; j++) {
            int bus;
            int size;
            f >> bus >> size;
            bus--;
            if (!f) {
                ostringstream ss;
                ss << "illegal output format discovered at delegation " << i + 1;
                err_code = 2;
                err_message = ss.str();
                return 0;
            }
            if (bus < cur_bus || bus >= m) {
                ostringstream ss;
                ss << "illegal bus " << bus + 1 << " at group " << j + 1 << " for delegation "
                   << i + 1;
                err_code = 1;
                err_message = ss.str();
                return 0;
            }
            if (size <= 0) {
                ostringstream ss;
                ss << "illegal size " << size << " at group " << j + 1 << " for delegation "
                   << i + 1;
                err_code = 1;
                err_message = ss.str();
                return 0;
            }
            delegation_size += size;
            if (bus > cur_bus) {
                cur_bus = bus;
                cur_size = 0;
            }
            cur_size += size;
            if (cur_size > b[cur_bus]) {
                ostringstream ss;
                ss << "overflow for bus " << bus + 1 << " at group " << j + 1
                   << " for delegation " << i + 1;
                err_code = 1;
                err_message = ss.str();
                return 0;
            }
        }
        if (delegation_size != a[i]) {
            ostringstream ss;
            ss << "illegal size for delegation " << i + 1 << " (" << delegation_size
               << " instead of " << a[i] << ")";
            err_code = 1;
            err_message = ss.str();
            return 0;
        }
    }
    return ans;
}

int main(int argc, char* argv[])
{
    ifstream fin(argv[1]);
    ifstream fout(argv[2]);
    ifstream fans(argv[3]);

    int sum_a = 0;
    fin >> n;
    for (int i = 0; i < n; i++) {
        fin >> a[i];
        sum_a += a[i];
    }
    int sum_b = 0;
    fin >> m;
    for (int i = 0; i < m; i++) {
        fin >> b[i];
        sum_b += b[i];
    }
    if (!fin) {
        cout << "invalid input file" << endl;
        return 3;
    }

    int jury_ans = get_answer(fans);
    if (err_code) {
        cout << "jury error: " << err_message << endl;
        return 3;
    }

    int contestant_ans = get_answer(fout);
    if (err_code) {
        cout << err_message << endl;
        return err_code;
    }

    if (jury_ans > contestant_ans) {
        cout << "contestant is better, " << contestant_ans << " groups vs " << jury_ans << endl;
        return 3;
    } else if (jury_ans < contestant_ans) {
        cout << "jury is better, " << jury_ans << " groups vs " << contestant_ans << endl;
        return 1;
    }

    cout << "ok (" << jury_ans << ")" << (sum_a == sum_b ? " saturation" : "") << endl;
    return 0;
}
