#include <sstream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <string>
#include <cassert>
#include <ctime>
#include <map>
#include <math.h>
#include <cstdio>
#include <set>
#include <deque>
#include <memory.h>
#include <queue>

#pragma comment(linker, "/STACK:64000000")
typedef long long ll;

using namespace std;

const int MAXK = -1;
const int MAXN = 105;
const int INF = 1e9;

struct pp {
	int i, j, ost, f;

	pp() {}
	pp(int ni, int nj, int nost, int nf) : i(ni), j(nj), ost(nost), f(nf) {}
};

int dp[MAXN][MAXN][MAXN][2];
pp p[MAXN][MAXN][MAXN][2];

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int n;
	bool first = 1;
	while (cin >> n) {
		if (first) first = 0;
		else cout << endl;
		vector<int> a(n);
		for (int i = 0; i < n; i++) cin >> a[i];
		int m;
		cin >> m;
		vector<int> b(m);
		for (int i = 0; i < m; i++) cin >> b[i];

		for (int i = 0; i <= n; i++) {
			for (int j = 0; j <= m; j++) {
				for (int k = 0; k < MAXN; k++) {
					for (int f = 0; f < 2; f++) {
						dp[i][j][k][f] = INF;
						p[i][j][k][f] = pp(-1, -1, -1, -1);
					}
				}
			}
		}
		dp[0][0][0][0] = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				for (int ost = 0; ost < MAXN; ost++) {
					for (int f = 0; f < 2; f++) {
						if (dp[i][j][ost][f] == INF) continue;
						if (f == 0) {
							if (dp[i][j + 1][ost][0] > dp[i][j][ost][0]) {
								dp[i][j + 1][ost][0] = dp[i][j][ost][0];
								p[i][j + 1][ost][0] = pp(i, j, ost, 0);
							}
							int ni, nj, nost, nf;
							if (a[i] - ost <= b[j]) {
								ni = i + 1;
								nj = j;
								nost = a[i] - ost;
								nf = 1;
							}
							else {
								ni = i;
								nj = j + 1;
								nost = ost + b[j];
								nf = 0;
							}
							if (dp[ni][nj][nost][nf] > dp[i][j][ost][0] + 1) {
								dp[ni][nj][nost][nf] = dp[i][j][ost][0] + 1;
								p[ni][nj][nost][nf] = pp(i, j, ost, 0);
							}
						}
						else {
							if (dp[i][j + 1][0][1] > dp[i][j][ost][1]) {
								dp[i][j + 1][0][1] = dp[i][j][ost][1];
								p[i][j + 1][0][1] = pp(i, j, ost, 1);
							}
							int ni, nj, nost, nf;
							if (a[i] <= b[j] - ost) {
								ni = i + 1;
								nj = j;
								nost = ost + a[i];
								nf = 1;
							}
							else {
								ni = i;
								nj = j + 1;
								nost = b[j] - ost;
								nf = 0;
							}
							if (dp[ni][nj][nost][nf] > dp[i][j][ost][1] + 1) {
								dp[ni][nj][nost][nf] = dp[i][j][ost][1] + 1;
								p[ni][nj][nost][nf] = pp(i, j, ost, 1);
							}
						}
					}
				}
			}
		}
		int ansI = n, ansJ = 0, ansOst = 0, ansF = 0;
		for (int j = 0; j < m; j++) {
			for (int ost = 0; ost < MAXN; ost++) {
				for (int f = 0; f < 2; f++) {
					if (dp[n][j][ost][f] < dp[ansI][ansJ][ansOst][ansF]) {
						ansI = n;
						ansJ = j;
						ansOst = ost;
						ansF = f;
					}
				}
			}
		}
		//cout << dp[ansI][ansJ][ansOst][ansF] << endl;
		vector<vector<pair<int, int> > > c(n);
		while (ansI != 0 || ansJ != 0 || ansOst != 0 || ansF != 0) {
			int pI = p[ansI][ansJ][ansOst][ansF].i;
			int pJ = p[ansI][ansJ][ansOst][ansF].j;
			int pOst = p[ansI][ansJ][ansOst][ansF].ost;
			int pF = p[ansI][ansJ][ansOst][ansF].f;

			if (dp[ansI][ansJ][ansOst][ansF] != dp[pI][pJ][pOst][pF]) {
				c[pI].push_back(make_pair(pJ, 0));
			}

			ansI = pI;
			ansJ = pJ;
			ansOst = pOst;
			ansF = pF;
		}
		for (int i = 0; i < n; i++) {
			cout << c[i].size() << endl;
			reverse(c[i].begin(), c[i].end());
			for (auto o : c[i]) {
				int k = min(a[i], b[o.first]);
				a[i] -= k;
				b[o.first] -= k;
				cout << o.first + 1 << " " << k << endl;
			}
		}
	}
	
	return 0;
}
